VERSION 5.00
Begin VB.UserControl TransparentForm 
   BackColor       =   &H00FFFF00&
   BackStyle       =   0  'Transparent
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   480
   ScaleWidth      =   480
End
Attribute VB_Name = "TransparentForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ClientToScreen Lib "user32" _
                (ByVal hwnd As Long, _
                lpPoint As PointAPI) As Long
                
Private Declare Function CreateRectRgn Lib "gdi32" _
                (ByVal X1 As Long, _
                ByVal Y1 As Long, _
                ByVal X2 As Long, _
                ByVal Y2 As Long) As Long
                
Private Declare Function SetWindowRgn Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal hRgn As Long, _
                ByVal bRedraw As Boolean) As Long
                
Private Declare Function GetWindowRgn Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal hRgn As Long) As Long
                
Private Declare Function OffsetRgn Lib "gdi32" _
                (ByVal hRgn As Long, _
                ByVal X As Long, _
                ByVal Y As Long) As Long
                
Private Declare Function GetClientRect Lib "user32" _
                (ByVal hwnd As Long, _
                lpRect As RectAPI) As Long
                
Private Declare Function GetCursorPos Lib "user32" _
                (lpPoint As PointAPI) As Long

Private Declare Function GetSystemMenu Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal bRevert As Long) As Long
                
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" _
                (ByVal hwnd As Long, _
                ByVal wMsg As Long, _
                ByVal wParam As Long, _
                ByVal lParam As Long) As Long

Private Declare Function TrackPopupMenu Lib "user32" _
                (ByVal hMenu As Long, _
                ByVal wFlags As Long, _
                ByVal X As Long, _
                ByVal Y As Long, _
                ByVal nReserved As Long, _
                ByVal hwnd As Long, _
                lprc As RectAPI) As Long

Private Type PointAPI
    X As Long
    Y As Long
End Type

Private Type RectAPI
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Const SIMPLEREGION      As Long = &H2&
Private Const COMPLEXREGION     As Long = &H3&
Private Const TPM_RETURNCMD     As Long = &H100&
Private Const WM_SYSCOMMAND     As Long = &H112&

Private Const m_DefTransparent  As Boolean = True
Private Const m_DefMaskColor    As Long = &HC0C0C0

Private m_Transparent   As Boolean
Private m_Disabled      As Boolean
Private m_MaskColor     As Long

Private WithEvents mParent  As Form
Attribute mParent.VB_VarHelpID = -1

Private Sub SetForm()

    ' Variable de sauvegarde de l'tat autoredraw de la form parente
    Dim bAutoRedraw     As Boolean
    ' Variable multi usage pour rsultat des l'appel d'API
    Dim lRet            As Long
    ' Variable de type de rgion
    Dim lRgnType        As Long
    ' Rgion temporaire
    Dim hWinRgn         As Long
    ' Variable d'offset X
    Dim lOffsetX        As Long
    ' Variable d'offset Y
    Dim lOffsetY        As Long
    ' Variable de largeur de la feuille mre
    Dim lScaleWidth     As Long
    ' Variable de hauteur de la feuille mre
    Dim lScaleHeight    As Long
    ' Structure de coordonnes temporaire
    Dim ptTemp          As PointAPI
    ' Structure de dimention de la feuille cliente
    Dim rcClient        As RectAPI

    ' Teste si on n'est pas en mode dveloppement exit si oui
    If Not Ambient.UserMode Then _
        GoTo NormalExit
    ' Sauvagarde le status autoredraw de la feuille parente
    bAutoRedraw = mParent.AutoRedraw
    ' Force sont status autoredraw  vrai
    mParent.AutoRedraw = True
    '
    ' Teste si la transparence est Active et si le controle est actif
    ' Si non dsactive la transparence (Dsactive la rgion)
    If m_Disabled Or Not m_Transparent Then _
        GoTo UnsetForm
    
    ' Teste la feuille mre dispose bien d'une image de fond
    If mParent.Picture = 0 Or mParent.Picture Is Nothing Then
        ' Si non dsactive la transparence (Dsactive la rgion)
        GoTo UnsetForm
    Else
        ' Copie les paramtres ncessaire de la feuille parente vers le controle
        With UserControl
            .MaskColor = m_MaskColor
            .Width = .ScaleX(mParent.Picture.Width, vbHimetric, vbTwips)
            .Height = .ScaleY(mParent.Picture.Height, vbHimetric, vbTwips)
            Set .Picture = mParent.Picture
            Set .MaskPicture = mParent.Picture
            DoEvents
        End With
    End If
    
    ' Cration d'une rgion "Bidon" pour passer en argument  l'APIGetWindowRgn
    hWinRgn = CreateRectRgn(0, 0, 200, 200)

    ' Capture de la rgion
    lRgnType = GetWindowRgn(UserControl.hwnd, hWinRgn)
    
    Select Case lRgnType
        '
        Case SIMPLEREGION, COMPLEXREGION
            '
            With mParent
                ' Lecture de la zone de la feuille mre
                lRet = GetClientRect(.hwnd, rcClient)
                ' Calcul de la largeur de la feuille
                lScaleWidth = (rcClient.Right - rcClient.Left + 1) * Screen.TwipsPerPixelX
                ' Calcul de la Hauteur de la feuille
                lScaleHeight = (rcClient.Bottom - rcClient.Top + 1) * Screen.TwipsPerPixelY
                '
                ' Redimentionnement de la feuille
                .Width = (.Width - lScaleWidth) + UserControl.Width + Screen.TwipsPerPixelX
                .Height = (.Height - lScaleHeight) + UserControl.Height + Screen.TwipsPerPixelY
                '
                ' Calcul offset pour les bords de la feuille et la barre de titre
                ptTemp.X = 0
                ptTemp.Y = 0
                lRet = ClientToScreen(.hwnd, ptTemp)
                lOffsetX = ptTemp.X - (.Left / Screen.TwipsPerPixelX)
                lOffsetY = ptTemp.Y - (.Top / Screen.TwipsPerPixelY)
                lRet = OffsetRgn(hWinRgn, lOffsetX, lOffsetY)
                '
                ' Activation de la rgion
                lRet = SetWindowRgn(.hwnd, hWinRgn, True)
            End With
        Case Else
            ' Erreur va supprimer la rgion
            GoTo UnsetForm
    End Select

NormalExit:
    ' Sortie normale du Sub
    ' Si Form Parente existe lui rendre sont tat Autoredraw d'origine
    If Not mParent Is Nothing Then _
        mParent.AutoRedraw = bAutoRedraw
    Exit Sub

UnsetForm:
    ' Suppresion de la rgion
    lRet = SetWindowRgn(mParent.hwnd, &H0&, True)
    GoTo NormalExit

End Sub

Private Sub mParent_Load()
    'Activation de la feuille mre va activer les rgions ...
    Call SetForm
End Sub

'
' Slection / Lecture de la couleur de Masque
'
Public Property Let MaskColor(ByVal lData As OLE_COLOR)
    m_MaskColor = lData
    PropertyChanged "MaskColor"
End Property

Public Property Get MaskColor() As OLE_COLOR
    MaskColor = m_MaskColor
End Property
'
' Slection / Lecture de l'activation de la transparence
'
Public Property Let Transparent(ByVal bData As Boolean)
    m_Transparent = bData
    Call SetForm
    PropertyChanged "Transparent"
End Property

Public Property Get Transparent() As Boolean
    Transparent = m_Transparent
End Property
'
' Initialisation proprits du controle
'
Private Sub UserControl_InitProperties()
    ' Slectionne la transparence par dfaut
    m_Transparent = m_DefTransparent
    ' Slection la couleur de Masque par dfaut
    m_MaskColor = m_DefMaskColor
End Sub
'
' Lectures des proprts du contrle
'
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim iCnt    As Integer
    Dim lIdx    As Long

    m_Transparent = PropBag.ReadProperty("Transparent", m_DefTransparent)
    m_MaskColor = PropBag.ReadProperty("MaskColor", m_DefMaskColor)
    
    ' Teste si on est en mode dveloppement
    If UserControl.Ambient.UserMode Then
        ' Affectation de la variable mParent
        Set mParent = UserControl.Parent
        ' On va vrifier qu'un seul contrle de transparence est sur la feuille
        ' Pour a, on numres tous les contrles contenus dans la feuille
        ' et on vrifi leur type
        For lIdx = 0 To mParent.Controls.Count - 1
            If TypeOf mParent.Controls(lIdx) Is TransparentForm Then
                ' Ici c'est le bon type
                If iCnt > 0 Then
                    ' Ici plusieurs contrles sur la feuille !!!
                    ' Affiche un message et dsactive le contrle
                    MsgBox "Seulement un contrle de transparence par feuille !" & _
                      "" & vbCrLf & vbCrLf & _
                      "Toutes les contrles de transparences seront dsactivs" & _
                      " pour cette feuille.", vbExclamation, "Multiple Controles"
                    ' Dsactive le contrle
                    m_Disabled = True
                    Exit For
                End If
                iCnt = iCnt + 1
            End If
        Next
    End If
    ' Application de la rgion
    Call SetForm
End Sub
'
' Sauvegarde des proprts du contrle
'
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Transparent", m_Transparent, m_DefTransparent)
    Call PropBag.WriteProperty("MaskColor", m_MaskColor, m_DefMaskColor)
End Sub
'
' Redimentionnement du contrle
'
Private Sub UserControl_Resize()
    If Not Ambient.UserMode Then
        ' Si Mode dveloppement Force les dimentions du contrle
        ' lorsqu'on le redimention
        If UserControl.Width <> 480 Then
            UserControl.Width = 480
        ElseIf UserControl.Height <> 480 Then
            UserControl.Height = 480
        Else
            Set UserControl.MaskPicture = UserControl.Picture
            UserControl.MaskColor = &HC0C0C0
        End If
    End If
End Sub

Public Sub Refresh()
    ' Application de la rgion
    Call SetForm
End Sub

Public Sub PopupSysMenu(Optional ByVal eFlags As MenuControlConstants = vbPopupMenuLeftAlign, Optional ByVal X As Variant, Optional ByVal Y As Variant)
    '
    ' Permet l'affichage du menu systme
    '
    ' Variable Handle du menu
    Dim hMenu   As Long
    ' Variable contenant la numro d'ID du menu cliqu
    Dim lMenuID As Long
    ' Flags d'options d'affichage du menu
    Dim lFlags  As Long
    ' Structure de coordonnes temporaire du curseur
    Dim ptTemp As PointAPI
    ' Structure de zone temporaire
    Dim rcTemp  As RectAPI

    ' Si contrle dsactiv sortie function
    If m_Disabled Then _
        Exit Sub
    
    ' Si les coordonnes de position du menu ne sont pas transmise
    ' on va lire les coordonnes actuelles de la souris
    If IsMissing(X) And IsMissing(Y) Then
        ' Lecture des coordonnes de la souris
        Call GetCursorPos(ptTemp)
    Else
        ' Si un des deux valeur est fourni on fixe l'autre  zro
        If IsMissing(X) Then X = 0
        If IsMissing(Y) Then Y = 0
        ' Conversion d'chelle de X & Y passs
        ptTemp.X = mParent.ScaleX(X, mParent.ScaleMode, vbPixels)
        ptTemp.Y = mParent.ScaleY(Y, mParent.ScaleMode, vbPixels)
        ' Conversion vers coordonnes d'cran en pixel
        Call ClientToScreen(mParent.hwnd, ptTemp)
    End If
    
    ' Capture du Handle du menu systme
    hMenu = GetSystemMenu(mParent.hwnd, &H0&)
    ' Si menu existant ou pas d'erruer
    If hMenu <> 0 Then
        ' Affichage du menu suivant options
        ' Constitution des options
        lFlags = eFlags Or TPM_RETURNCMD
        ' Affichage du menu
        lMenuID = TrackPopupMenu(hMenu, lFlags, ptTemp.X, _
                  ptTemp.Y, &H0&, mParent.hwnd, rcTemp)
        ' Envoyer l'information vers la feuille si un menu est cliqu
        If lMenuID <> 0 Then _
            Call PostMessage(mParent.hwnd, WM_SYSCOMMAND, lMenuID, hMenu)
    End If
End Sub
